import { DftGrpRelease, dftGrpActionItem, dftGrpactionColumn } from './basDefectGrp';
import { DeleteEntity } from '/@/api/tigerapi/system';
import { ActionItem, BasicColumn } from '/@/components/Table';

export function GetActionsData(params: {}, ...args: Fn[]) {
  let data = [
    {
      icon: 'clarity:note-edit-line',
      onClick: editRecord.bind(null, args[0], params),
    },
    {
      icon: 'ant-design:delete-outlined',
      color: 'error',
      popConfirm: {
        title: '是否确认删除?',
        placement: 'left',
        confirm: deleteRecord.bind(null, args[1], params),
      },
    },
  ] as ActionItem[];
  switch (params.entityName) {
    case 'BAS_DEFECT_GRP':
      const _d = dftGrpActionItem;
      _d[0].onClick = DftGrpRelease.bind(null, args[1], params);
      data = [...data, ..._d];
      break;
  }
  return data;
}

function editRecord(fn: Fn, params: {}) {
  fn(true, params);
}

function deleteRecord(fn: Fn, params: {}) {
  console.log(params.record);
  //删除
  const apiAction = DeleteEntity(params.record, params.entityName);
  apiAction.then((action) => {
    if (action.IsSuccessed) {
      fn();
    }
  });
}

export function GetActionColumn(entityName: string) {
  let data: BasicColumn = {};
  switch (entityName) {
    case 'BAS_DEFECT_GRP':
      data = dftGrpactionColumn;
      break;
    default:
      data = {
        width: 80,
        title: '操作',
        dataIndex: 'action',
        slots: { customRender: 'action' },
        fixed: undefined,
      };
      break;
  }
  return data;
}
